global cNullCast, gObjects, gEnvironmentSound, gCursorlist, gKeyRef, cNUllCharmovie

on DoTest
end

on doOpenJuliapanel
  set the movieRate of sprite 36 to 0
  updateStage()
  OpenCloseADDobj(#Juliapanel)
end

on CalcTransToA19
  if (getaProp(getaProp(gStates, #Conditions), #Trailer) = #true) and voidp(getaProp(getaProp(gStates, #BeenThere), #A19B)) then
    return #A19B
  else
    return #A19
  end if
end

on exitWindowShade
  if getaProp(getaProp(gObjects, #Windowshade), #State) = #open then
    OpenClose(#Windowshade)
  end if
  DelClockSolved()
end

on ExitJuliaPanel
  global sQTCharSprite
  if getaProp(getaProp(gObjects, #Juliapanel), #State) = #open then
    OpenCloseADDobj(#Juliapanel)
    set the movieRate of sprite sQTCharSprite to 0
  end if
  DoRadioChannel()
end

on DoJuliaPanel
  set OBj to getaProp(gObjects, #Juliapanel)
  if getaProp(OBj, #State) = #open then
    set the loop of cast cNUllCharmovie to 0
    set the loc of sprite getaProp(getaProp(gObjects, #JuliaPaint), #SpriteNum) to point(-2000, -2000)
    updateStage()
    set the movieRate of sprite getaProp(getaProp(gObjects, #JuliaPaint), #SpriteNum) to 0
  else
    set the loop of cast cNUllCharmovie to 1
    DoCharacterMovie(#JuliaPaint)
  end if
end

on EnterClockDoor
  DoRadioChannel()
  if getaProp(getaProp(gObjects, #ClockDrawer), #solved) = #true then
    AddObjects([#ClockAnimreg])
  else
    AddObjects([#ClockAnimChaos])
  end if
end

on ExitClockDoor
  if getaProp(getaProp(gObjects, #ClockDrawer), #solved) = #true then
    DelObjects([#ClockAnimreg])
  else
    DelObjects([#ClockAnimChaos])
  end if
end

on ExitSinKnob
  if getaProp(getaProp(gObjects, #SinKnob), #State) = #open then
    OpenCloseADDobj(#SinKnob)
  end if
end

on DoradioPower
  set OBj to getaProp(gObjects, #RadioPower)
  if getaProp(OBj, #State) = #on then
    DoRadioChannel()
  else
    DoRadioChannel()
    MakeDynamic(#RadioPower, #AmbientSound, #NULL)
  end if
  MakeDynamic(#RadioPower, #DisplayState, getaProp(OBj, #State))
end

on testmetimer
  set a to the timer
  playSound("A3DJ.aif", #File, 1)
  put the timer - a
end

on DoRadioChannel
  if getaProp(gStates, #EnviroLetter) = "a" then
    set power to getaProp(gObjects, #RadioPower)
    set OBj to getaProp(gObjects, #RadioChannel)
    if voidp(getaProp(OBj, #IntroPlay)) then
      MakeDynamic(#RadioChannel, #IntroPlay, playSound("A3DJ.aif", #File))
      Startthetimer(1225, "DoRadioChannel")
    else
      set asound to getaProp(getaProp(OBj, #AmbientSound), getaProp(OBj, #State))
      set IntroSound to CheckPlayingintroSound(OBj)
      if getaProp(power, #State) = #on then
        if IntroSound = #done then
          if getOne([#A09, #A13], gKeyRef) = 0 then
            playSound(asound, #AmbientLoop)
            MakeDynamic(#RadioChannel, #DisplayState, getaProp(OBj, #State))
          else
            Startthetimer(60, "DoRadioChannel")
          end if
        end if
      else
        if getaProp(power, #State) <> #on then
          if IntroSound = #done then
            stopsound(asound)
          else
            stopsound("A3DJ.aif")
            setaProp(OBj, #IntroPlay, #done)
          end if
        end if
      end if
    end if
  end if
end

on CheckPlayingintroSound OBj
  set Channel to getaProp(OBj, #IntroPlay)
  if Channel = #done then
    return #done
  else
    if soundBusy(Channel) then
      if getaProp(getaProp(gSoundchannels, Channel), #name) = "A3DJ.aif" then
        stopsound(Channel)
        setaProp(OBj, #IntroPlay, #done)
        return #done
      end if
    else
      setaProp(OBj, #IntroPlay, #done)
      return #done
    end if
  end if
end

on DoclockMag MagNum
  set OBj to getaProp(gObjects, #ClockDrawer)
  set Childref to getAt(getaProp(OBj, #Children), MagNum)
  set Child to getaProp(gObjects, Childref)
  MakeDynamic(Childref, #loc, getaProp(Child, #loc))
  if inside(getaProp(Child, #loc), getaProp(OBj, #TestRect)) then
    setAt(getaProp(OBj, #MagsOut), MagNum, 0)
  else
    setAt(getaProp(OBj, #MagsOut), MagNum, 1)
  end if
  if getOne(getaProp(OBj, #MagsOut), 0) > 0 then
    MakeDynamic(#ClockDrawer, #solved, #false)
    MakeDynamic(#TVPhoneOBJ, #solved, #false)
    MakeDynamic(#JuliaPaint, #solved, #false)
    stopsound("A11tik.aif")
    playSound("A11clock.aif", #cast)
  else
    MakeDynamic(#ClockDrawer, #solved, #true)
    stopsound("A11clock.aif")
    playSound("A10ckfix.aif", #cast, 1)
    playSound("A11tik.aif", #cast)
  end if
end

on EnterA13
  SetTimeDail()
end

on DoaDial OBJref
  set OBj to getaProp(gObjects, OBJref)
  set thehots to getaProp(OBj, #thehotrects)
  set CurNum to getaProp(OBj, #time)
  set lastrect to getaProp(OBj, #DisplayState)
  repeat while the mouseDown
    set currect to InahotRect(thehots, the mouseH, the mouseV)
    if (currect <> #empty) and (lastrect <> currect) then
      set the castNum of sprite getaProp(OBj, #SpriteNum) to getaProp(getaProp(OBj, #cast), currect)
      set the loc of sprite getaProp(OBj, #SpriteNum) to getAt(getaProp(OBj, #thelocs), currect)
      updateStage()
      if (currect > lastrect) or ((lastrect = 16) and (currect = 1)) then
        set CurNum to CurNum + 1
      else
        if (currect < lastrect) or ((lastrect = 1) and (currect = 16)) then
          set CurNum to CurNum - 1
        end if
      end if
      if CurNum > getaProp(OBj, #TimeVal) then
        set CurNum to getaProp(OBj, #startTime)
      end if
      if CurNum < getaProp(OBj, #startTime) then
        set CurNum to getaProp(OBj, #TimeVal)
      end if
      MakeDynamic(OBJref, #time, CurNum)
      SetTimeDail()
      set lastrect to currect
    end if
  end repeat
  ResetHotRects(OBJref)
  MakeDynamic(OBJref, #DisplayState, lastrect)
end

on SetTimeDail
  set Hour to getaProp(getaProp(gObjects, #JuliaDialHour), #time)
  set min to getaProp(getaProp(gObjects, #JuliaDialMin), #time)
  if Hour < 10 then
    set Hour to string("0" & Hour)
  end if
  if min < 10 then
    set min to string("0" & min)
  end if
  set theTime to Hour & ":" & min
  set the text of cast getaProp(getaProp(getaProp(gObjects, #JuliaTime), #cast), #time) to theTime
end

on CheckDailTime
  set movObj to getaProp(gObjects, #JuliaPaint)
  set the loc of sprite getaProp(getaProp(gObjects, #JuliaCircle2), #SpriteNum) to point(-2000, -2000)
  if (the text of cast getaProp(getaProp(getaProp(gObjects, #JuliaTime), #cast), #time) = "02:59") and (getaProp(getaProp(gObjects, #ClockDrawer), #solved) = #true) then
    MakeDynamic(#JuliaPaint, #DisplayState, #right)
    set the castNum of sprite getaProp(getaProp(gObjects, #JuliaGreenBut), #SpriteNum) to getaProp(getaProp(getaProp(gObjects, #JuliaGreenBut), #cast), #down)
    set the castNum of sprite getaProp(getaProp(gObjects, #JuliaRedBut), #SpriteNum) to getaProp(getaProp(getaProp(gObjects, #JuliaRedBut), #cast), #UP)
    MakeDynamic(#JuliaPaint, #solved, #true)
  else
    MakeDynamic(#JuliaPaint, #DisplayState, #Wrong)
    set the castNum of sprite getaProp(getaProp(gObjects, #JuliaGreenBut), #SpriteNum) to getaProp(getaProp(getaProp(gObjects, #JuliaGreenBut), #cast), #UP)
    set the castNum of sprite getaProp(getaProp(gObjects, #JuliaRedBut), #SpriteNum) to getaProp(getaProp(getaProp(gObjects, #JuliaRedBut), #cast), #down)
    MakeDynamic(#JuliaPaint, #solved, #false)
    MakeDynamic(#TVPhoneOBJ, #solved, #false)
  end if
  DoCharacterMovie(#JuliaPaint)
  repeat while the movieTime of sprite getaProp(movObj, #SpriteNum) < the stopTime of sprite getaProp(movObj, #SpriteNum)
    CursorandUpdate()
  end repeat
  MakeDynamic(#JuliaPaint, #DisplayState, #Paint)
  set the loc of sprite getaProp(movObj, #SpriteNum) to point(-2000, -2000)
  set the loc of sprite getaProp(getaProp(gObjects, #JuliaCircle2), #SpriteNum) to getaProp(getaProp(gObjects, #JuliaCircle), #loc)
end

on InahotRect Hotrects, H, V
  set nHotr to count(Hotrects)
  repeat with X = 1 to nHotr
    if inside(point(H, V), getAt(Hotrects, X)) then
      return X
    end if
  end repeat
  return #empty
end

on ResetHotRects OBJref
  set OBj to getaProp(gObjects, OBJref)
  set hotrectnum to integer(getaProp(OBj, #SpriteNum) & "01")
  MakeDynamic(OBJref, #loc, the loc of sprite getaProp(OBj, #SpriteNum))
  setAt(getaProp(OBj, #Hotrect), 1, the rect of sprite getaProp(OBj, #SpriteNum))
  setaProp(getaProp(gHotRects, hotrectnum), #rect, getAt(getaProp(OBj, #Hotrect), 1))
end

on AddClocksolved
  if getaProp(getaProp(gObjects, #ClockDrawer), #solved) = #false then
    set asound to "A11clock.aif"
    set Clocks to [#A06: [#Clock1], #A07: [#clock3], #A10: [#clock2]]
    AddObjects(getaProp(Clocks, getaProp(gCurKeyList, #RefName)))
  else
    set asound to "A11tik.aif"
  end if
  if gKeyRef = #A06 then
    stopsound(asound)
  else
    playSound(asound, #cast)
  end if
end

on DelClockSolved
  if getaProp(getaProp(gObjects, #ClockDrawer), #solved) = #false then
    set Clocks to [#A06: [#Clock1], #A07: [#clock3], #A10: [#clock2]]
    DelObjects(getaProp(Clocks, getaProp(gCurKeyList, #RefName)))
  end if
end

on CalcHavePDA RefLoc
  put RefLoc
  if getaProp(getaProp(gObjects, #PDAOBJ), #Aquired) = #false then
    set RefLoc to value("#" & RefLoc & "A")
  else
    set RefLoc to value("#" & RefLoc & "B")
  end if
  return RefLoc
end

on PDAGrab
  ReleaseUNVobject(#PDAOBJ)
end

on ClearClocksound
  AddClocksolved()
  puppetSound(0)
end
